# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_int
from typing import Literal
import twnet_parser.enum6 as enum6

class MsgSvSoundGlobal(PrettyPrint):
    def __init__(
            self,
            chunk_header: ChunkHeader = ChunkHeader(),
            sound_id: int = enum6.Sound.GUN_FIRE.value
    ) -> None:
        self.message_type: Literal['system', 'game'] = 'game'
        self.message_name: str = 'sv_sound_global'
        self.system_message: bool = False
        self.message_id: int = 5
        self.header: ChunkHeader = chunk_header

        self.sound_id: int = sound_id

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.sound_id = unpacker.get_int() # enum SOUND
        return True

    def pack(self) -> bytes:
        return pack_int(self.sound_id)