# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_int, pack_str
from typing import Literal

class MsgMapChange(PrettyPrint):
    def __init__(
            self,
            chunk_header: ChunkHeader = ChunkHeader(),
            name: str = 'default',
            crc: int = 0,
            size: int = 0
    ) -> None:
        self.message_type: Literal['system', 'game'] = 'system'
        self.message_name: str = 'map_change'
        self.system_message: bool = True
        self.message_id: int = 2
        self.header: ChunkHeader = chunk_header

        self.name: str = name
        self.crc: int = crc
        self.size: int = size

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.name = unpacker.get_str()
        self.crc = unpacker.get_int()
        self.size = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_str(self.name) + \
            pack_int(self.crc) + \
            pack_int(self.size)