# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_int
from typing import Literal, Optional

class MsgMapData(PrettyPrint):
    def __init__(
            self,
            chunk_header: ChunkHeader = ChunkHeader(),
            last: int = 0,
            crc: int = 0,
            chunk: int = 0,
            data_size: Optional[int] = None,
            data: bytes = b'\x00'
    ) -> None:
        self.message_type: Literal['system', 'game'] = 'system'
        self.message_name: str = 'map_data'
        self.system_message: bool = True
        self.message_id: int = 3
        self.header: ChunkHeader = chunk_header

        self.last: int = last
        self.crc: int = crc
        self.chunk: int = chunk
        self.data_size: int = data_size if data_size else len(data)
        self.data: bytes = data

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.last = unpacker.get_int()
        self.crc = unpacker.get_int()
        self.chunk = unpacker.get_int()
        self.data_size = unpacker.get_int()
        self.data = unpacker.get_raw(self.data_size)
        return True

    def pack(self) -> bytes:
        return pack_int(self.last) + \
            pack_int(self.crc) + \
            pack_int(self.chunk) + \
            pack_int(self.data_size) + \
            self.data