# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_int
from typing import Literal

class MsgRequestMapData(PrettyPrint):
    def __init__(
            self,
            chunk_header: ChunkHeader = ChunkHeader(),
            chunk: int = 0
    ) -> None:
        self.message_type: Literal['system', 'game'] = 'system'
        self.message_name: str = 'request_map_data'
        self.system_message: bool = True
        self.message_id: int = 19
        self.header: ChunkHeader = chunk_header

        self.chunk: int = chunk

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.chunk = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_int(self.chunk)