# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int

class ObjFlag(PrettyPrint):
    def __init__(
            self,
            x: int = 0,
            y: int = 0,
            team: int = 0
    ) -> None:
        self.item_name: str = 'connless.flag'
        self.type_id: int = 5
        self.id: int = 0

        self.x: int = x
        self.y: int = y
        self.team: int = team

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.x = unpacker.get_int()
        self.y = unpacker.get_int()
        self.team = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_int(self.x) + \
            pack_int(self.y) + \
            pack_int(self.team)