# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int

class ObjGameInfo(PrettyPrint):
    def __init__(
            self,
            game_flags: int = 0,
            game_state_flags: int = 0,
            round_start_tick: int = 0,
            warmup_timer: int = 0,
            score_limit: int = 0,
            time_limit: int = 0,
            round_num: int = 0,
            round_current: int = 0
    ) -> None:
        self.item_name: str = 'connless.game_info'
        self.type_id: int = 6
        self.id: int = 0

        self.game_flags: int = game_flags
        self.game_state_flags: int = game_state_flags
        self.round_start_tick: int = round_start_tick
        self.warmup_timer: int = warmup_timer
        self.score_limit: int = score_limit
        self.time_limit: int = time_limit
        self.round_num: int = round_num
        self.round_current: int = round_current

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.game_flags = unpacker.get_int()
        self.game_state_flags = unpacker.get_int()
        self.round_start_tick = unpacker.get_int()
        self.warmup_timer = unpacker.get_int()
        self.score_limit = unpacker.get_int()
        self.time_limit = unpacker.get_int()
        self.round_num = unpacker.get_int()
        self.round_current = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_int(self.game_flags) + \
            pack_int(self.game_state_flags) + \
            pack_int(self.round_start_tick) + \
            pack_int(self.warmup_timer) + \
            pack_int(self.score_limit) + \
            pack_int(self.time_limit) + \
            pack_int(self.round_num) + \
            pack_int(self.round_current)