# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int
import twnet_parser.enum6 as enum6

class ObjPlayerInfo(PrettyPrint):
    def __init__(
            self,
            local: int = 0,
            client_id: int = 0,
            team: int = enum6.Team.SPECTATORS.value,
            score: int = 0,
            latency: int = 0
    ) -> None:
        self.item_name: str = 'connless.player_info'
        self.type_id: int = 10
        self.id: int = 0

        self.local: int = local
        self.client_id: int = client_id
        self.team: int = team
        self.score: int = score
        self.latency: int = latency

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.local = unpacker.get_int()
        self.client_id = unpacker.get_int()
        self.team = unpacker.get_int() # enum TEAM
        self.score = unpacker.get_int()
        self.latency = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_int(self.local) + \
            pack_int(self.client_id) + \
            pack_int(self.team) + \
            pack_int(self.score) + \
            pack_int(self.latency)