# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int
import twnet_parser.enum6 as enum6

class ObjSoundGlobal(PrettyPrint):
    def __init__(
            self,
            sound_id: int = enum6.Sound.GUN_FIRE.value
    ) -> None:
        self.item_name: str = 'connless.sound_global'
        self.type_id: int = 18
        self.id: int = 0

        self.sound_id: int = sound_id

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.sound_id = unpacker.get_int() # enum SOUND
        return True

    def pack(self) -> bytes:
        return pack_int(self.sound_id)