# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int

class ObjSpectatorInfo(PrettyPrint):
    def __init__(
            self,
            spectator_id: int = 0,
            x: int = 0,
            y: int = 0
    ) -> None:
        self.item_name: str = 'connless.spectator_info'
        self.type_id: int = 12
        self.id: int = 0

        self.spectator_id: int = spectator_id
        self.x: int = x
        self.y: int = y

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.spectator_id = unpacker.get_int()
        self.x = unpacker.get_int()
        self.y = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_int(self.spectator_id) + \
            pack_int(self.x) + \
            pack_int(self.y)