# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int

class ObjDamage(PrettyPrint):
    def __init__(
            self,
            client_id: int = 0,
            angle: int = 0,
            health_amount: int = 0,
            armor_amount: int = 0,
            self_: bool = False
    ) -> None:
        self.item_name: str = 'connless.damage'
        self.type_id: int = 22
        self.id: int = 0

        self.client_id: int = client_id
        self.angle: int = angle
        self.health_amount: int = health_amount
        self.armor_amount: int = armor_amount
        self.self_: bool = self_

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.client_id = unpacker.get_int()
        self.angle = unpacker.get_int()
        self.health_amount = unpacker.get_int()
        self.armor_amount = unpacker.get_int()
        self.self_ = unpacker.get_int() == 1
        return True

    def pack(self) -> bytes:
        return pack_int(self.client_id) + \
            pack_int(self.angle) + \
            pack_int(self.health_amount) + \
            pack_int(self.armor_amount) + \
            pack_int(self.self_)